package cn.com.capcloud.core.system.acl;

import cn.com.capcloud.ccui.core.common.json.JackJSON;
import com.alibaba.druid.util.StringUtils;
import org.apache.commons.io.IOUtils;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;

import javax.servlet.ReadListener;
import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

/**
 * @author: wangyinfeng
 * @create: 2022/1/6
 */
public class ParameterRequestWrapper extends HttpServletRequestWrapper {
    private Map<String , String[]> params = new HashMap<>();

    public ParameterRequestWrapper(HttpServletRequest request) {
        // 将request交给父类，以便于调用对应方法的时候，将其输出，其实父亲类的实现方式和第一种new的方式类似
        super(request);
        //将参数表，赋予给当前的Map以便于持有request中的参数
        Map<String, String[]> requestMap=request.getParameterMap();
        this.params.putAll(requestMap);
        this.modifyParameterValues();
    }

    /**
     * 重写getInputStream方法  post类型的请求参数必须通过流才能获取到值
     */
    @Override
    public ServletInputStream getInputStream() throws IOException {
        /** 非json类型，直接返回 */
        if(!super.getHeader(HttpHeaders.CONTENT_TYPE).equalsIgnoreCase(MediaType.APPLICATION_JSON_VALUE)){
            return super.getInputStream();
        }

        //为空，直接返回
        String json = IOUtils.toString(super.getInputStream(), "utf-8");
        if (StringUtils.isEmpty(json)) {
            return super.getInputStream();
        }
         json = clearXss(json);
        Map<String,Object> map= StringJsonUtils.jsonStringToMap(json);
        /**
         * 解决raw json中值含int或long值时，接口拿不到完整的json，在 Spring Boot 2.7 版本中没有这个问题，但升级到 Spring Boot 3.5 后出现了此问题。后续需要进一步排查原因。
         */
        //ByteArrayInputStream bis = new ByteArrayInputStream(JackJSON.toJSONString(map).getBytes("utf-8"));
        ByteArrayInputStream bis = new ByteArrayInputStream(json.getBytes("utf-8"));
        return new MyServletInputStream(bis);
    }

    private String clearXss(String value) {
        if (value == null || "".equals(value)) { return value; }
        // (?i)匹配符  忽略大小写内容
        // 移除常见的 JavaScript 事件处理程序，比如 onerror、onclick 等
        value = value.replaceAll("(?i)\\bon[a-zA-Z]+\\b", "");  // 移除所有以 'on' 开头的事件处理程序，如 'onerror'、'onclick' 等
        //value = value.replaceAll("(?i)script", "");//使用这个当字段名含的时候会被替换为空，比如备注字段名是：description
        value = value.replaceAll("(?i)<script.*?>.*?</script>", "");
        value = value.replaceAll("(?i)truncate", "");
        value = value.replaceAll("(?i)'", "&quot;"); //对单引号转义，以防止SQL注入
        value = value.replaceAll("(?i)<", "&lt;");   // 对小于号转义
        value = value.replaceAll("(?i)>", "&gt;");   // 对大于号转义
        return value;
    }


    /**
     * @Description:  将parameter的值去除空格后重写回去
     */
    public void modifyParameterValues(){
        Set<String> set = params.keySet();
        Iterator<String> it = set.iterator();
        while(it.hasNext()){
            String key= it.next();
            String[] values = params.get(key);
            values[0] = values[0].trim();
            params.put(key, values);
        }
    }

    @Override
    public String getParameter(String name) {
        String[]values = params.get(name);
        if(values == null || values.length == 0) {
            return null;
        }
        return values[0];
    }
    /**
     * @Description:  重写getParameterValues
     */
    @Override
    public String[] getParameterValues(String name) {//同上
        return params.get(name);
    }

    class MyServletInputStream extends ServletInputStream {
        private ByteArrayInputStream bis;
        public MyServletInputStream(ByteArrayInputStream bis){
            this.bis=bis;
        }
        @Override
        public boolean isFinished() {
            return true;
        }

        @Override
        public boolean isReady() {
            return true;
        }

        @Override
        public void setReadListener(ReadListener listener) {

        }
        @Override
        public int read(){
            return bis.read();
        }
    }
}
